Avoid -u option to id since solaris doesn't support it.
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
6f481bb0 20tmpdir="$scratchdir"
e3442095
WD
21fromdir="$tmpdir/from"
22todir="$tmpdir/to"
23chkdir="$tmpdir/chk"
3a4c683f 24
fc29efc3
WD
25# For itemized output:
26all_plus='+++++++++'
27allspace=' '
28dots='.....' # trailing dots after changes
29
2094283b 30# Berkley's nice.
96553aa7 31PATH="$PATH:/usr/ucb"
2094283b 32
21706678 33if diff -u "$suitedir/rsync.fns" "$suitedir/rsync.fns" >/dev/null 2>&1; then
84229c7a
WD
34 diffopt="-u"
35else
36 diffopt="-c"
37fi
38
a98cad00
WD
39HOME="$scratchdir"
40export HOME
41
3a4c683f
MP
42runtest() {
43 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
44 if eval "$2"
45 then
6f481bb0 46 echo "$ECHO_T done."
501972bf
MP
47 return 0
48 else
6f481bb0 49 echo "$ECHO_T failed!"
501972bf
MP
50 return 1
51 fi
3a4c683f
MP
52}
53
844810d6
WD
54set_cp_destdir() {
55 while test $# -gt 1; do
56 shift
57 done
58 destdir="$1"
59}
60
61# Perform a "cp -p", making sure that timestamps are really the same,
62# even if the copy rounded microsecond times on the destination file.
63cp_touch() {
64 cp -p "${@}" || test_fail "cp -p failed"
65 if test $# -gt 2 -o -d "$2"; then
66 set_cp_destdir "${@}" # sets destdir var
67 while test $# -gt 1; do
68 destname="$destdir/`basename $1`"
69 touch -r "$destname" "$1" "$destname"
70 shift
71 done
72 else
73 touch -r "$2" "$1" "$2"
74 fi
75}
76
757287d8
WD
77# Call this if you want to filter out verbose messages (-v or -vv) from
78# the output of an rsync run (whittling the output down to just the file
79# messages). This isn't needed if you use -i without -v.
80filter_outfile() {
81 sed -e '/^building file list /d' \
9544261a 82 -e '/^sending incremental file list/d' \
757287d8
WD
83 -e '/^created directory /d' \
84 -e '/^done$/d' \
85 -e '/ --whole-file$/d' \
86 -e '/^total: /d' \
332cf6df
WD
87 -e '/^client charset: /d' \
88 -e '/^server charset: /d' \
757287d8
WD
89 -e '/^$/,$d' \
90 <"$outfile" >"$outfile.new"
91 mv "$outfile.new" "$outfile"
92}
93
3a4c683f
MP
94printmsg() {
95 echo "$1"
96}
97
6773a779 98rsync_ls_lR() {
db9c9e27 99 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls" $TLS_ARGS
dfef3f10
MP
100}
101
8e7f3107
WD
102get_testuid() {
103 id 2>/dev/null | sed 's/^[^0-9]*\([0-9][0-9]*\).*/\1/'
104}
105
18d7e9f4 106check_perms() {
eace352b
WD
107 perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-d]\(.........\).*/\1/'`
108 if test $perms = $2; then
109 return 0
110 fi
111 echo "permissions: $perms on $1"
112 echo "should be: $2"
113 test_fail "failed test $3"
18d7e9f4
WD
114}
115
dfef3f10
MP
116rsync_getgroups() {
117 "$TOOLDIR/getgroups"
57835c00
MP
118}
119
120
e052b21f 121####################
6f481bb0 122# Build test directories $todir and $fromdir, with $fromdir full of files.
e052b21f 123
3a4c683f 124hands_setup() {
501972bf 125 # Clean before creation
6f481bb0
WD
126 rm -rf "$fromdir"
127 rm -rf "$todir"
3d807132 128
e3442095
WD
129 [ -d "$tmpdir" ] || mkdir "$tmpdir"
130 [ -d "$fromdir" ] || mkdir "$fromdir"
131 [ -d "$todir" ] || mkdir "$todir"
3a4c683f 132
e052b21f
MP
133 # On some BSD systems, the umask affects the mode of created
134 # symlinks, even though the mode apparently has no effect on how
135 # the links behave in the future, and it cannot be changed using
136 # chmod! rsync always sets its umask to 000 so that it can
137 # accurately recreate permissions, but this script is probably run
138 # with a different umask.
139
140 # This causes a little problem that "ls -l" of the two will not be
141 # the same. So, we need to set our umask before doing any creations.
142
3a4c683f 143 # set up test data
6f481bb0
WD
144 touch "$fromdir/empty"
145 mkdir "$fromdir/emptydir"
e8ca5901 146
571a4b26 147 # a hundred lines of text or so
6f481bb0 148 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
3a4c683f 149
6f481bb0 150 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
0154b302 151 umask 0
6f481bb0 152 ln -s nolf "$fromdir/nolf-symlink"
4c80c473 153 umask 022
0154b302 154
db10766a 155 cat "$srcdir"/*.c > "$fromdir/text"
6f481bb0
WD
156 mkdir "$fromdir/dir"
157 cp "$fromdir/text" "$fromdir/dir"
158 mkdir "$fromdir/dir/subdir"
159 echo some data > "$fromdir/dir/subdir/foobar.baz"
160 mkdir "$fromdir/dir/subdir/subsubdir"
a7a1cc2c
WD
161 if [ -r /etc ]; then
162 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
163 else
164 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
165 fi
6f481bb0 166 mkdir "$fromdir/dir/subdir/subsubdir2"
a7a1cc2c
WD
167 if [ -r /bin ]; then
168 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
169 else
170 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
171 fi
7d691654 172
8f98c608 173# echo testing head:
6f481bb0 174# ls -lR "$srcdir" | head -10 || echo failed
3a4c683f 175}
3fedd74b
MP
176
177
99cdaff7
MP
178####################
179# Many machines do not have "mkdir -p", so we have to build up long paths.
180# How boring.
5ef8c5c6 181makepath() {
d1798a2f
WD
182 for p in "${@}"; do
183 (echo " makepath $p"
184
99cdaff7
MP
185 # Absolut Unix.
186 if echo $p | grep '^/' >/dev/null
187 then
188 cd /
189 fi
190
d1798a2f 191 # This will break if $p contains a space.
99cdaff7
MP
192 for c in `echo $p | tr '/' ' '`
193 do
112e7311
MP
194 if [ -d "$c" ] || mkdir "$c"
195 then
196 cd "$c" || return $?
197 else
198 echo "failed to create $c" >&2; return $?
199 fi
d1798a2f
WD
200 done)
201 done
99cdaff7
MP
202}
203
204
205
3fedd74b
MP
206###########################
207# Run a test (in '$1') then compare directories $2 and $3 to see if
208# there are any difference. If there are, explain them.
209
f494f286
MP
210# So normally basically $1 should be an rsync command, and $2 and $3
211# the source and destination directories. This is only good when you
212# expect to transfer the whole directory exactly as is. If some files
213# should be excluded, you might need to use something else.
214
3fedd74b 215checkit() {
3fedd74b 216 failed=
3fedd74b 217
cf72f204
MP
218 # We can just write everything to stdout/stderr, because the
219 # wrapper hides it unless there is a problem.
220
221 echo "Running: \"$1\""
222 eval "$1"
3fedd74b
MP
223 status=$?
224 if [ $status != 0 ]; then
225 failed="YES";
226 fi
227
cf72f204
MP
228 echo "-------------"
229 echo "check how the directory listings compare with diff:"
230 echo ""
6f481bb0
WD
231 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
232 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
233 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
30688bf1
WD
234
235 echo "-------------"
236 echo "check how the files compare with diff:"
237 echo ""
238 if [ "x$4" != x ]; then
239 echo " === Skipping (as directed) ==="
240 else
241 diff -r $diffopt "$2" "$3" || failed=YES
242 fi
243
244 echo "-------------"
6f481bb0 245 if [ -z "$failed" ] ; then
3fedd74b
MP
246 return 0
247 else
3fedd74b
MP
248 return 1
249 fi
250}
251
863dff51 252
4a7cb3e8 253build_rsyncd_conf() {
d2094cc3
MP
254 # Build an appropriate configuration file
255 conf="$scratchdir/test-rsyncd.conf"
256 echo "building configuration $conf"
257
258 port=2612
259 pidfile="$scratchdir/rsyncd.pid"
260 logfile="$scratchdir/rsyncd.log"
e5255195 261 hostname=`uname -n`
d2094cc3 262
aa381148
WD
263 uid_setting='uid = 0'
264 gid_setting='gid = 0'
8e7f3107 265 case `get_testuid` in
aa381148
WD
266 0) ;;
267 *)
268 # Non-root cannot specify uid & gid settings
269 uid_setting="#$uid_setting"
270 gid_setting="#$gid_setting"
271 ;;
272 esac
273
6f481bb0 274 cat >"$conf" <<EOF
3aae15ec 275# rsyncd configuration file autogenerated by $0
d2094cc3 276
3aae15ec
MP
277pid file = $pidfile
278use chroot = no
9585b276 279munge symlinks = no
e73eed85 280hosts allow = localhost 127.0.0.0/24 192.168.0.0/16 10.0.0.0/8 $hostname
3aae15ec 281log file = $logfile
2ae4126a
WD
282log format = %i %h [%a] %m (%u) %l %f%L
283transfer logging = yes
0e9c3564 284exclude = ? foobar.baz
951e826b 285max verbosity = 4
aa381148
WD
286$uid_setting
287$gid_setting
98c1b325 288
2e6c7f45 289[test-from]
6f481bb0 290 path = $fromdir
3aae15ec 291 read only = yes
0e9c3564 292 comment = r/o
d2094cc3 293
2e6c7f45 294[test-to]
6f481bb0 295 path = $todir
3aae15ec 296 read only = no
0e9c3564 297 comment = r/w
2ae4126a
WD
298
299[test-scratch]
300 path = $scratchdir
301 read only = no
0e9c3564
WD
302
303[test-hidden]
304 path = $fromdir
305 list = no
d2094cc3 306EOF
2d8f9b1d
WD
307
308 # Build a helper script to ignore exit code 23
309 ignore23="$scratchdir/ignore23"
310 echo "building help script $ignore23"
311
312 cat >"$ignore23" <<'EOT'
313if "${@}"; then
314 exit
315fi
316
317ret=$?
318
319if test $ret = 23; then
320 exit
321fi
322
323exit $ret
324EOT
325chmod +x "$ignore23"
d2094cc3
MP
326}
327
328
3cd2af41 329build_symlinks() {
3cd2af41
MP
330 mkdir "$fromdir"
331 date >"$fromdir/referent"
332 ln -s referent "$fromdir/relative"
333 ln -s "$fromdir/referent" "$fromdir/absolute"
334 ln -s nonexistent "$fromdir/dangling"
1db8b61d 335 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
336}
337
338test_fail() {
339 echo "$@" >&2
340 exit 1
341}
342
a217ad30
MP
343test_skipped() {
344 echo "$@" >&2
6f481bb0 345 echo "$@" > "$tmpdir/whyskipped"
a217ad30
MP
346 exit 77
347}
348
be2f866b
MP
349# It failed, but we expected that. don't dump out error logs,
350# because most users won't want to see them. But do leave
351# the working directory around.
352test_xfail() {
353 echo "$@" >&2
354 exit 78
355}
356
d1239eae
MP
357# Determine what shell command will appropriately test for links.
358ln -s foo "$scratchdir/testlink"
359for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
360do
361 for switch in -h -L
362 do
363 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
364 then
365 # how nice
366 TEST_SYMLINK_CMD="$cmd $switch"
367 # i wonder if break 2 is portable?
368 break 2
369 fi
370 done
371done
cca4e067
MP
372# ok, now get rid of it
373rm "$scratchdir/testlink"
d1239eae
MP
374
375
376if [ "x$TEST_SYMLINK_CMD" = 'x' ]
377then
378 test_fail "Couldn't determine how to test for symlinks"
379else
380 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
381fi
382
383
d96d3893
MP
384# Test whether something is a link, allowing for shell peculiarities
385is_a_link() {
d1239eae
MP
386 # note the variable contains the first option and therefore is not quoted
387 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
388}
389
77867907
MP
390
391# We need to set the umask to be reproducible. Note also that when we
392# do some daemon tests as root, we will setuid() and therefore the
393# directory has to be writable by the nobody user in some cases. The
394# best thing is probably to explicitly chmod those directories after
395# creation.
396
ad301e48 397umask 022